﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using Buddy.Coroutines;
using ff14bot.AClasses;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using Clio.Utilities;
using ff14bot;
using ff14bot.Interfaces;
using ff14bot.Objects;
using System.Diagnostics;
using ff14bot.Navigation;


namespace Stuck
{
    public class Stuck : ff14bot.AClasses.BotPlugin
    {
        private StuckForm _settingsForm;
        public override string Author { get { return "dark wolf"; } }
        public string Description { get { return "Concept Study for stuck."; } }
        public override Version Version { get { return new Version(1, 5, 2); } }
        public bool Equals(ff14bot.AClasses.BotPlugin other)
        {
            throw new NotImplementedException();
        }

        Stopwatch stopwatch = new Stopwatch();
        Stopwatch timeout = new Stopwatch();
        Stopwatch loop = new Stopwatch();
        private Vector3 OrginalLocation = new Vector3("0,0,0");
        private Coroutine _coroutine;
        private List<float> moved = new List<float>();
        private Vector3 LastLocation = new Vector3("0,0,0");
        private int stage = 0;

        public override void OnInitialize()
        {
            OrginalLocation = Core.Player.Location;
            LastLocation = Core.Player.Location;
            stage = 0;
            Logging.Write("DEBUG resetcounter= {0}", Settings.Instance.resetcounter);
            Logging.Write("DEBUG FailedTeleport= {0}", Settings.Instance.FailedTeleport);
            Logging.Write("DEBUG StopBot= {0}", Settings.Instance.StopBot);
            Logging.Write("DEBUG Loop= {0}", Settings.Instance.Loop);
        }

        public override void OnPulse()
        {

            if (timeout.IsRunning)
            {
                if (timeout.ElapsedMilliseconds > Settings.Instance.resetcounter*1000)
                {
                    stage = 0;
                    Logging.Write("Reseting stuckwatch after {0}", Settings.Instance.resetcounter);
                    timeout.Stop();
                }
            }
            else
            {
                if (stage != 0)
                {
                    timeout.Restart();
                }
            }
            if (Settings.Instance.Loop > 0 && loop.IsRunning && loop.ElapsedMilliseconds > (Settings.Instance.Loop * 1000))
            {
                Logging.Write("Infinite Loop protection expired. Stopping Timer");
                loop.Stop();
            }
                        


            switch (stage)
            {
                case 0:
                    if (stopwatch.IsRunning)
                    {
                        if (stopwatch.ElapsedMilliseconds < 10000) { return; }
                        var distance = Core.Player.Distance(OrginalLocation);
                        if (distance < 1f)
                        {
                            stage = 1;
                            Logging.Write("First Indication for Stuck");
                           // System.IO.File.WriteAllText(@"I:\reborn\stuck.txt", "First Indication for Stuck");
                        }

                        stopwatch.Stop();
                    }
                    else if (MovementManager.IsMoving == true && MovementManager.Speed != 0f && !Core.Player.InCombat)
                    {
                        Logging.Write("Update location Stage 0");
                        OrginalLocation = Core.Me.Location;
                        stopwatch.Restart();
                    }

                    break;
                case 1:
                    if (MovementManager.IsMoving == true && MovementManager.Speed > 0 && !Core.Player.InCombat)
                    {
                        //we should be moving according and not beeing in combat
                        //Logging.Write("Distance since last pulse:{0}", Core.Player.Distance(LastLocation));
                        moved.Add(Core.Player.Distance(LastLocation));
                        LastLocation = Core.Player.Location;
                        float ave = moved.Aggregate((acc, cur) => acc + cur) / moved.Count;
                        if (ave < 0.30)
                        {
                            Logging.Write("Second indication that we are stuck now lets take actions");
                         //   System.IO.File.AppendAllText(@"I:\reborn\stuck.txt", "Second indication that we are stuck now lets take actions");
                            stage = 2;
                        }

                        //Logging.Write("average distances {0} on {1} items", ave, moved.Count);
                        if (moved.Count > 50)
                        { moved.RemoveRange(0, 25); }
                    }

                    break;
                case 2:
                    Logging.Write("Trying to Jump");

                    MovementManager.Jump();
                    Thread.Sleep(1500);
                    MovementManager.Jump();
                    Thread.Sleep(1500);
                    MovementManager.Jump();
                    stage = 3;
                    break;
                case 3:
                    if (stopwatch.IsRunning)
                    {
                        if (stopwatch.ElapsedMilliseconds < 10000) { return; }
                        var distance = Core.Player.Distance(OrginalLocation);
                        if (distance < 1f)
                        {
                            stage = 4;
                          //  System.IO.File.AppendAllText(@"I:\reborn\stuck.txt", "Jumping did not help");
                            Logging.Write("Jumping did not help");
                        }

                        stopwatch.Stop();
                    }
                    else if (MovementManager.IsMoving == true && MovementManager.Speed != 0f && !Core.Player.InCombat)
                    {
                        Logging.Write("Update location stage 3");
                        OrginalLocation = Core.Me.Location;
                        stopwatch.Restart();
                    }

                    break;
                case 4:
                  
                    
                    Logging.Write("Lets get out of here");
                    if (Core.Player.IsMounted)
                    {
                        Logging.Write("We are mounted lets dismount");
                        Actionmanager.Dismount();
                    }
                    if (MovementManager.IsMoving == true)
                    {
                        Navigator.PlayerMover.MoveStop();
                        Logging.Write("Stopping any movement");
                    }
                    var currentZone=WorldManager.ZoneId;
                    //Tuple<uint, Vector3>[] Aetherytes = new Tuple<uint, Vector3>();
                    uint _AetheryteId = WorldManager.AetheryteIdsForZone(WorldManager.ZoneId).FirstOrDefault().Item1;
                    Logging.Write("Teleprotin to {0}", _AetheryteId);
                    WorldManager.TeleportById(_AetheryteId);
                    Thread.Sleep(20000);
                    if (currentZone== WorldManager.ZoneId)
                    { Logging.Write("Teleporting Failed");
                    if(Settings.Instance.FailedTeleport)
                        Logging.Write("Stop Bot on Teleport failure requested...Stopping bot");
                    stage = 0;
                        TreeRoot.Stop();

                    }
                    if(Settings.Instance.StopBot)
                    {
                        Logging.Write("Stop Bot on Stuck requested...Stopping bot");
                        stage = 0;
                        TreeRoot.Stop();
                       
                    }
                    if (Settings.Instance.Loop > 0 && !loop.IsRunning)
                    { Logging.Write("Starting infinite loop counter");
                        loop.Restart();

                    }
                    if (Settings.Instance.Loop > 0 && loop.IsRunning)
                    {
                        Logging.Write("Checking Infinite Loop Protection");
                        if (loop.ElapsedMilliseconds < (Settings.Instance.Loop * 1000))
                        {
                            Logging.Write("Teleport withing the loop prevention stopping bot");
                            stage = 0;
                            TreeRoot.Stop();
                        }
                        
                      

                    }
                    break;

            }


        }

        public override string Name
        {
            get { return "Stuck!"; }
        }
        public override bool WantButton
        {
            get { return true; }
        }

        public override void OnButtonPress()
        {
            if (_settingsForm == null || _settingsForm.IsDisposed || _settingsForm.Disposing)
                _settingsForm = new StuckForm();

            _settingsForm.ShowDialog();
        }
        public override void OnShutdown()
        {
            stage = 0;
        }
        public override void OnEnabled()
        {
            Logging.Write("DEBUG resetcounter= {0}", Settings.Instance.resetcounter);
            Logging.Write("DEBUG FailedTeleport= {0}", Settings.Instance.FailedTeleport);
            Logging.Write("DEBUG StopBot= {0}", Settings.Instance.StopBot);
            Logging.Write("DEBUG Loop= {0}", Settings.Instance.Loop);
 
            stage = 0;
        }
        public override void OnDisabled()
        {
            stage = 0;
        }
        public override string ButtonText
        {
            get { return "Stuck!"; }
        }
       

    }
}
